/**
  *  \file client/chart-color.cc
  *
  *  (c) 2001-2005 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "client/chart.h"
#include "game/player.h"

/** Get color scheme to use for the specified player. Classifies the
    specified player, and returns the color. */
UIColor::Color
getPlayerColor(int player)
{
    static const UIColor::Color data[] = {
        UIColor::tc_Green,
        UIColor::tc_Yellow,
        UIColor::tc_Red
    };
    
    if (player <= 0 || player >= NUM_OWNERS)
        return UIColor::tc_Static;
    else
        return getPlayerRelation(player)[data];
}
