/**
  *  \file flak/flakdefs.cc
  *  \brief Structure Definitions (Conversion Information)
  *  \ingroup FLAK Structures
  *
  *  Automatically generated by scripts/iogen.pl from flak/flakdefs.in
  *
  *  (c) 2001-2005 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "flak/flakdefs.h"

/** Conversion information. Describes how to convert a
    TFlakShip structure to and from DOS. */
const TStructureParser TFlakShip::parser[] = {
    { T_RSTRING, 20, offsetof(TFlakShip, name), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, damage_init), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, crew_init), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, id), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, player), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, hull), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, level), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, beam_count), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, beam_type), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, torp_lcount), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, torp_count), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, torp_type), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, bay_count), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, fighter_count), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, mass), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, shield_init), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, max_fighters_launched), 0, 0 },
    { T_INT32, 1, offsetof(TFlakShip, rating), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, compensation_rating), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, flags), 0, 0 },
    { T_INT16, 1, offsetof(TFlakShip, ending_status), 0, 0 },
    { T_END, 0, 0, 0, 0 }
};
/** Conversion information. Describes how to convert a
    TFlakFleet structure to and from DOS. */
const TStructureParser TFlakFleet::parser[] = {
    { T_INT16, 1, offsetof(TFlakFleet, player), 0, 0 },
    { T_INT16, 1, offsetof(TFlakFleet, first_ship), 0, 0 },
    { T_INT16, 1, offsetof(TFlakFleet, num_ships), 0, 0 },
    { T_INT16, 1, offsetof(TFlakFleet, speed), 0, 0 },
    { T_INT32, 1, offsetof(TFlakFleet, att_list_pointer), 0, 0 },
    { T_INT32, 1, offsetof(TFlakFleet, att_list_size), 0, 0 },
    { T_INT32, 1, offsetof(TFlakFleet, x_init), 0, 0 },
    { T_INT32, 1, offsetof(TFlakFleet, y_init), 0, 0 },
    { T_END, 0, 0, 0, 0 }
};
/** Conversion information. Describes how to convert a
    TFlakBattle structure to and from DOS. */
const TStructureParser TFlakBattle::parser[] = {
    { T_INT32, 1, offsetof(TFlakBattle, this_size), 0, 0 },
    { T_INT16, 1, offsetof(TFlakBattle, x), 0, 0 },
    { T_INT16, 1, offsetof(TFlakBattle, y), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, seed), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, total_time), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, ambient_flags), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, num_fleets), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, fleet_entry_size), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, fleet_ptr), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, num_ships), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, ship_entry_size), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, ship_ptr), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, num_att_list_entries), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, att_list_entry_size), 0, 0 },
    { T_INT32, 1, offsetof(TFlakBattle, att_list_ptr), 0, 0 },
    { T_END, 0, 0, 0, 0 }
};
/** Conversion information. Describes how to convert a
    TFlakHeader structure to and from DOS. */
const TStructureParser TFlakHeader::parser[] = {
    { T_STRING, 8, offsetof(TFlakHeader, magic), 0, 0 },
    { T_INT16, 1, offsetof(TFlakHeader, filefmt_version), 0, 0 },
    { T_INT16, 1, offsetof(TFlakHeader, player), 0, 0 },
    { T_INT16, 1, offsetof(TFlakHeader, turn), 0, 0 },
    { T_INT16, 1, offsetof(TFlakHeader, num_battles), 0, 0 },
    { T_STRING, 18, offsetof(TFlakHeader, timestamp), 0, 0 },
    { T_INT32, 1, offsetof(TFlakHeader, reserved), 0, 0 },
    { T_END, 0, 0, 0, 0 }
};
