/**
  *  \file subr.h
  *
  *  (c) 2001-2005 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef SUBR_H_INCLUDED
#define SUBR_H_INCLUDED

#include "cpluslib/string.h"
#include "cpluslib/types.h"

class IntExecutionContext;

class IntSubroutine {
    uint32   uid;
    int      ref_count;

 protected:
    IntSubroutine();
    virtual ~IntSubroutine();

 public:
    virtual void run(int nargs, string_t name, IntExecutionContext& xc) = 0;

    void incUseCount() { ++ref_count; }
    void decUseCount() { --ref_count; }
    void setSubrName(string_t name);

    uint32 getId() const { return uid; }

    static IntSubroutine* getSubrByName(string_t name);
    static IntSubroutine* getSubrByIndex(uint32 id);
};

#endif
